#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <cmath>
#include <iomanip>

using namespace std;

#define SQR(x) ((x)*(x))

const int maxn = 12;

int n, m;
int sx[maxn], sy[maxn];
int ax[maxn], ay[maxn], bx[maxn], by[maxn], dd[maxn];
double d_out, d_etalon;
double ddd[3*maxn][3*maxn];

double dist(int u, int v)
{
    double ux, uy;
    if (u < m) {ux = ax[u]; uy = ay[u];}
    else if (u < m+m) {ux = bx[u-m]; uy = by[u-m];}
    else {ux = sx[u-m-m]; uy = sy[u-m-m];}

    double vx, vy;
    if (v < m) {vx = ax[v]; vy = ay[v];}
    else if (v < m+m) {vx = bx[v-m]; vy = by[v-m];}
    else {vx = sx[v-m-m]; vy = sy[v-m-m];}
    
    return sqrt(SQR(ux-vx) + SQR(uy-vy));
}

double calc(ifstream &f)
{
    int i, j, k;
    double res = 0;
    for (i = 0; i < n; i++) {
        f >> k;
        if (k < 0 || k > m) {
            cout << "illegal plan len " << k << endl;
            return -1;
        }
        vector<int> num, dir;
        for (j = 0; j < k; j++) {
            int t;
            f >> t; num.push_back(t-1);
            if (t <= 0 || t > m) {
                cout << "illegal task " << t << endl;
                return -1;
            }
            f >> t; dir.push_back(t);
            if (t != 0 && t != 1) {
                cout << "illegal dir " << t << endl;
                return -1;
            }
        }
        
        int p = 2*m + i;
        double cur = 0;
        for (j = 0; j < k; j++) {
            if (dir[j] == 0) {
                cur += ddd[p][num[j]] + dd[num[j]];
                p = m + num[j];
            } else {
                cur += ddd[p][m+num[j]] + dd[num[j]];
                p = num[j];
            }
        }
        if (cur > res) res = cur;
    }
    if (!f) {
        cout << "illegal file (PE)";
        return -1;
    }    
    return res;
}

int main(int argc, char* argv[])
{
    ifstream f_in(argv[1]);
    ifstream f_out(argv[2]);
    ifstream f_ans(argv[3]);

    int i, j;

    f_in >> n >> m;      
    for (i = 0; i < n; i++) {
        f_in >> sx[i] >> sy[i];
    }
    for (i = 0; i < m; i++) {
        f_in >> ax[i] >> ay[i] >> bx[i] >> by[i] >> dd[i];
    }

    for (i = 0; i < 2*m+n; i++) {
        for (j = 0; j < 2*m+n; j++) {
            ddd[i][j] = dist(i, j);
        }
    }
    
    d_etalon = calc(f_ans);
    if (d_etalon < 0) {
        cout << " | jury bug" << endl;
        return 3;
    }

    d_out = calc(f_out);
    if (d_out < 0) {
        cout << " | contestant bug" << endl;
        return 1;
    }
    
    if (d_etalon > d_out + 1e-6) {
        cout << fixed << setprecision(7) << "jury WA: " << d_etalon << " vs " << d_out << endl;
        return 3;
    }
    if (d_out > d_etalon + 1e-6) {
        cout << fixed << setprecision(7) << "WA: " << d_etalon << " vs " << d_out << endl;
        return 1;
    }

    cout << "ok" << endl;
    return 0;
}
